"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.zMock = exports.testSearch = exports.testTrigger = exports.testCreate = exports.setApp = exports.describe = exports.allowNet = exports.appTester = exports.App = void 0;
const lodash_1 = require("lodash");
const nock_1 = __importDefault(require("nock"));
const zapier_platform_core_1 = __importDefault(require("zapier-platform-core"));
function allowNet() {
    nock_1.default.enableNetConnect();
}
exports.allowNet = allowNet;
function describe(title, cb) {
    return global.describe(title, () => {
        beforeEach(async () => {
            nock_1.default.cleanAll();
            nock_1.default.disableNetConnect();
        });
        cb();
    });
}
exports.describe = describe;
function setApp(appRaw) {
    exports.appTester = zapier_platform_core_1.default.createAppTester(appRaw);
    exports.App = appRaw;
}
exports.setApp = setApp;
function testCreate(key, bundle) {
    return exports.appTester(exports.App.creates[key].operation.perform, bundle);
}
exports.testCreate = testCreate;
function testTrigger(key, bundle) {
    return exports.appTester(exports.App.triggers[key].operation.perform, bundle);
}
exports.testTrigger = testTrigger;
function testSearch(key, bundle) {
    return exports.appTester(exports.App.searches[key].operation.perform, bundle);
}
exports.testSearch = testSearch;
const withEntity = (entity, fn) => {
    const appRaw = {};
    lodash_1.set(appRaw, [`${entity}s`, "test", "operation", "perform"], fn);
    const appTester = zapier_platform_core_1.default.createAppTester(appRaw);
    return (bundle) => appTester(fn, bundle);
};
exports.zMock = {
    create: (fn) => withEntity("create", fn),
    trigger: (fn) => withEntity("trigger", fn),
    search: (fn) => withEntity("search", fn),
};
//# sourceMappingURL=app_tester.js.map