import { ZObject, Bundle as ZBundle } from "zapier-platform-core";

interface ZapierEntity {
  [key: string]: {
    key: string;
    operation: {
      perform: (z: ZObject, bundle: Bundle) => Promise<object>;
    };
  };
}

export type ZapierApp = {
  creates: ZapierEntity;
  triggers: ZapierEntity;
  searches: ZapierEntity;
};

export type Bundle = Partial<ZBundle>;

export type ZPerform = (z: ZObject, bundle: Bundle) => Promise<object>;
